<script>
    import { validateSelf } from 'lib/validate'

    export let type
    export let name
    export let placeholder
    export let value
    export let rules = []
    export let errors = []

    const typeAction = node => (node.type = type)

    export const validate = async () => {
        errors = await validateSelf(rules, value)
        return errors.length === 0
    }
</script>

<label>
    <slot />
    <input
        use:typeAction
        {name}
        {placeholder}
        class:error={errors.length}
        bind:value
    />
    <ul>
        {#each errors as error}
            <li>{error}</li>
        {/each}
    </ul>
</label>

<style lang="postcss">
    label {
        @apply block text-lg text-blueGray-700;

        input {
            @apply block min-w-0 w-full bg-blueGray-100 text-blueGray-700 p-4 mt-2 rounded-l-3xl;

            &.error {
                @apply outline-none ring-4 ring-red-500 ring-opacity-50;
            }

            &:focus {
                @apply outline-none ring-4 ring-teal-500 ring-opacity-50;
            }
        }

        ul {
            @apply list-disc list-inside;

            li {
                @apply text-sm text-red-500;

                &:first-of-type {
                    @apply mt-2;
                }
            }
        }
    }
</style>
